/**
 * ******************************************************************************
 *  Copyright Fujitsu.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  You may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * *****************************************************************************
 *
 *  NIFCLOUD SDK for Java
 *
 */
package com.nifty.cloud.sdk.nattable.model;

import com.nifty.cloud.sdk.Request;
import com.nifty.cloud.sdk.annotation.Action;
import com.nifty.cloud.sdk.annotation.Query;

/**
 * NiftyReplaceNatTableAssociationリクエストクラス。<br />
 * このクラスはNiftyReplaceNatTableAssociationへのリクエストを構築します。
 *
 */
@Action("NiftyReplaceNatTableAssociation")
public class NiftyReplaceNatTableAssociationRequest implements Request {

	/** NATテーブル適用ID */
	private String associationId;

	/** NATテーブルID */
	private String natTableId;

	/** version up実施したのち、バックアップ状態を解除する事項への同意 */
	private Boolean agreement;

	/**
	 * デフォルトコンストラクタ。
	 */
	public NiftyReplaceNatTableAssociationRequest() {
	}

	/**
	 * NATテーブル適用ID,NATテーブルIDを指定し、NiftyReplaceNatTableAssociationRequestを構築します。
	 *
	 * @param associationId NATテーブル適用ID
	 * @param natTableId NATテーブルID
	 */
	public NiftyReplaceNatTableAssociationRequest(String associationId, String natTableId) {
		this.associationId = associationId;
		this.natTableId = natTableId;
	}

	/**
	 * NATテーブル適用IDを取得します。
	 *
	 * @return NATテーブル適用ID
	 */
	@Query(name="AssociationId", require=true)
	public String getAssociationId() {
		return associationId;
	}

	/**
	 * NATテーブル適用IDを設定します。
	 *
	 * @param associationId NATテーブル適用ID
	 */
	public void setAssociationId(String associationId) {
		this.associationId = associationId;
	}

	/**
	 * NATテーブル適用IDを設定し、自オブジェクトを返します。
	 *
	 * @param associationId NATテーブル適用ID
	 * @return 自オブジェクト
	 */
	public NiftyReplaceNatTableAssociationRequest withAssociationId(String associationId) {
		setAssociationId(associationId);
		return this;
	}

	/**
	 * NATテーブルIDを取得します。
	 *
	 * @return NATテーブルID
	 */
	@Query(name="NatTableId", require=true)
	public String getNatTableId() {
		return natTableId;
	}

	/**
	 * NATテーブルIDを設定します。
	 *
	 * @param natTableId NATテーブルID
	 */
	public void setNatTableId(String natTableId) {
		this.natTableId = natTableId;
	}

	/**
	 * NATテーブルIDを設定し、自オブジェクトを返します。
	 *
	 * @param natTableId NATテーブルID
	 * @return 自オブジェクト
	 */
	public NiftyReplaceNatTableAssociationRequest withNatTableId(String natTableId) {
		setNatTableId(natTableId);
		return this;
	}

	/**
	 * version up実施したのち、バックアップ状態を解除する事項への同意を取得します。
	 *
	 * @return version up実施したのち、バックアップ状態を解除する事項への同意
	 */
	@Query(name="Agreement")
	public Boolean getAgreement() {
		return agreement;
	}

	/**
	 * version up実施したのち、バックアップ状態を解除する事項への同意を設定します。
	 *
	 * @param agreement version up実施したのち、バックアップ状態を解除する事項への同意
	 */
	public void setAgreement(Boolean agreement) {
		this.agreement = agreement;
	}

	/**
	 * version up実施したのち、バックアップ状態を解除する事項への同意を設定し、自オブジェクトを返します。
	 *
	 * @param agreement version up実施したのち、バックアップ状態を解除する事項への同意
	 * @return 自オブジェクト
	 */
	public NiftyReplaceNatTableAssociationRequest withAgreement(Boolean agreement) {
		setAgreement(agreement);
		return this;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("[associationId=");
		builder.append(associationId);
		builder.append(", natTableId=");
		builder.append(natTableId);
		builder.append(", agreement=");
		builder.append(agreement);
		builder.append("]");
		return builder.toString();
	}
}
